# Dishes for HexOcean

https://dishes-5lbx6lbgwq-lz.a.run.app/

repository: https://gitlab.com/kat.lopuch/dishes

## Setup Application

Node version: 16.14.0

NPM version: 8.3.1

1. Open bash terminal in the root directory of the repository.
2. Install dependencies.

```
$ npm install
```

3. Run application.

```
$ npm start
```

4. Run tests (optional)

```
$ npm test
```

## Google Cloud Platform Deployment

1. Create _Dockerfile_ to describe docker image that contains ReactJs application. Keep in mind that the application should use the port number read from `PORT` environment variable.
2. Create docker image with the given tag

```
$ docker build -t dishes:1.0 .

# You can try starting image using docker compose file with following comment
$ docker-compose -f docker-compose.yml up
$ docker-compose -f docker-compose.yml down
```

3. Install gcloud CLI *https://cloud.google.com/sdk/docs/install*
4. Log in to the gcloud by running the following command

```
$ gcloud auth login
```

5. Configure Docker to access Google Cloud Container Registry

```
gcloud auth configure-docker
```

6. Create new project in Google Cloud project name: dishes and turn it on
7. Tag the docker image

```
# Tag: <Container Registry Domain>/<Project ID>/<Image Name>
$ docker tag dishes:1.0 gcr.io/soy-ascent-383019/dishes:1.0
```

8. Upload the image to Google Cloud

```
$ docker push gcr.io/soy-ascent-383019/dishes:1.0
```

9. Go to Google Cloud Run and create new service with the previously uploaded docker image
10. Use the URL generated by Google Cloud Run to open your page
    https://dishes-5lbx6lbgwq-lz.a.run.app/
